// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_common_msgs:msg/ReturnCode.idl
// generated code does not contain a copyright notice
#include "rc_common_msgs/msg/detail/return_code__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `message`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_common_msgs__msg__ReturnCode__init(rc_common_msgs__msg__ReturnCode * msg)
{
  if (!msg) {
    return false;
  }
  // value
  // message
  if (!rosidl_runtime_c__String__init(&msg->message)) {
    rc_common_msgs__msg__ReturnCode__fini(msg);
    return false;
  }
  return true;
}

void
rc_common_msgs__msg__ReturnCode__fini(rc_common_msgs__msg__ReturnCode * msg)
{
  if (!msg) {
    return;
  }
  // value
  // message
  rosidl_runtime_c__String__fini(&msg->message);
}

bool
rc_common_msgs__msg__ReturnCode__are_equal(const rc_common_msgs__msg__ReturnCode * lhs, const rc_common_msgs__msg__ReturnCode * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // value
  if (lhs->value != rhs->value) {
    return false;
  }
  // message
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->message), &(rhs->message)))
  {
    return false;
  }
  return true;
}

bool
rc_common_msgs__msg__ReturnCode__copy(
  const rc_common_msgs__msg__ReturnCode * input,
  rc_common_msgs__msg__ReturnCode * output)
{
  if (!input || !output) {
    return false;
  }
  // value
  output->value = input->value;
  // message
  if (!rosidl_runtime_c__String__copy(
      &(input->message), &(output->message)))
  {
    return false;
  }
  return true;
}

rc_common_msgs__msg__ReturnCode *
rc_common_msgs__msg__ReturnCode__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_common_msgs__msg__ReturnCode * msg = (rc_common_msgs__msg__ReturnCode *)allocator.allocate(sizeof(rc_common_msgs__msg__ReturnCode), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_common_msgs__msg__ReturnCode));
  bool success = rc_common_msgs__msg__ReturnCode__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_common_msgs__msg__ReturnCode__destroy(rc_common_msgs__msg__ReturnCode * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_common_msgs__msg__ReturnCode__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_common_msgs__msg__ReturnCode__Sequence__init(rc_common_msgs__msg__ReturnCode__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_common_msgs__msg__ReturnCode * data = NULL;

  if (size) {
    data = (rc_common_msgs__msg__ReturnCode *)allocator.zero_allocate(size, sizeof(rc_common_msgs__msg__ReturnCode), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_common_msgs__msg__ReturnCode__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_common_msgs__msg__ReturnCode__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_common_msgs__msg__ReturnCode__Sequence__fini(rc_common_msgs__msg__ReturnCode__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_common_msgs__msg__ReturnCode__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_common_msgs__msg__ReturnCode__Sequence *
rc_common_msgs__msg__ReturnCode__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_common_msgs__msg__ReturnCode__Sequence * array = (rc_common_msgs__msg__ReturnCode__Sequence *)allocator.allocate(sizeof(rc_common_msgs__msg__ReturnCode__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_common_msgs__msg__ReturnCode__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_common_msgs__msg__ReturnCode__Sequence__destroy(rc_common_msgs__msg__ReturnCode__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_common_msgs__msg__ReturnCode__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_common_msgs__msg__ReturnCode__Sequence__are_equal(const rc_common_msgs__msg__ReturnCode__Sequence * lhs, const rc_common_msgs__msg__ReturnCode__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_common_msgs__msg__ReturnCode__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_common_msgs__msg__ReturnCode__Sequence__copy(
  const rc_common_msgs__msg__ReturnCode__Sequence * input,
  rc_common_msgs__msg__ReturnCode__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_common_msgs__msg__ReturnCode);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_common_msgs__msg__ReturnCode * data =
      (rc_common_msgs__msg__ReturnCode *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_common_msgs__msg__ReturnCode__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_common_msgs__msg__ReturnCode__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_common_msgs__msg__ReturnCode__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
